// Script assets have changed for v2.3.0 see
// https://help.yoyogames.com/hc/en-us/articles/360005277377 for more information
function Scr_function_list(){

}


/*
//================= Function List ======================

init_part_animate()
play_part_animate(animate_max,animate_speed)

draw_ani_part_ext(cellwidth,cellheight,_x,_y,spr,subimg,dir,frame,dir_part,col,alpha)
draw_ani_part_scaled_ext(cellwidth,cellheight,_x,_y,spr,subimg,dir,frame,dir_part,xsca,ysca,col,alpha)
draw_ani_part_mirror(cellwidth,cellheight,_x,_y,spr,subimg,dir,img_numb,dir_part,col,alpha)

//================= Function List END ======================


ex)
sprite name : Spr_sorceress_8
maximum animate : 8
animate speed : 0.3
image width : 61
image height : 76



//----- Create Event
init_part_animate();

//----- Step Event
play_part_animate(8,0.3);

//----- Draw Event
var _x,_y;
_x=x-sprite_get_xoffset(sprite_index);
_y=y-sprite_get_yoffset(sprite_index);

draw_ani_part_ext(61,76,_x,_y,Spr_sorceress_8,0,direction,animate,8,c_white,1);

*/


function init_part_animate(){
animate=0;
}


function play_part_animate(animate_max,animate_speed){
var _img_max,_spd;
_spd=animate_speed;
_img_max=animate_max-_spd;

if animate<_img_max{animate+=_spd;}else{animate=0;}
}



function draw_ani_part_ext(cellwidth,cellheight,_x,_y,spr,subimg,dir,frame,dir_part,col,alpha){
//image angle 0~360
var _img_n,_dir,_ang,_dir_n,_w,_h;
_w=cellwidth;//cell size
_h=cellheight;//cell size
_img_n=floor(frame);

_ang=360/dir_part;

_dir_n=abs(round((dir mod 360)*(1/_ang)));
if _dir_n>=dir_part{_dir_n=0;}

draw_sprite_part_ext(spr,subimg,_img_n*_w,_dir_n*_h,_w,_h,_x,_y,1,1,col,alpha);
//end
}


function draw_ani_part_scaled_ext(cellwidth,cellheight,_x,_y,spr,subimg,dir,frame,dir_part,xsca,ysca,col,alpha){
//image angle 0~360
var _img_n,_ang,_dir_n,_w,_h;
_w=cellwidth;//cell size
_h=cellheight;//cell size
_img_n=floor(frame);

_ang=360/dir_part;

_dir_n=abs(round((dir mod 360)*(1/_ang)));
if _dir_n>=dir_part{_dir_n=0;}

draw_sprite_part_ext(spr,subimg,_img_n*_w,_dir_n*_h,_w,_h,_x,_y,xsca,ysca,col,alpha);
//end
}



function draw_ani_part_mirror(cellwidth,cellheight,_x,_y,spr,subimg,dir,img_numb,dir_part,col,alpha){
//90~0, 360~270 mirror
//use image angle 0~90, 360~270
var _spr,_img,_img_n,_part,_ang,_dir_n,_w,_h,_ch,_sca;
_w=cellwidth;//cell size
_h=cellheight;//cell size
_x=_x;
_y=_y-(_h/2);
_spr=spr;
_img=subimg;
_img_n=floor(img_numb);

_part=dir_part;
_ang=360/_part;//part

_ch=abs(round((dir mod 360)*(1/_ang)));
if _ch>=_part{_dir_n=0;}

//mirror
if !(_ch>_part/4 && _ch<_part-(_part/4)){_sca=1;_x-=(_w/2);}else{_sca=-1;_x+=(_w/2);}

var _a,_n;
_a=_part/4;_n=0;
repeat(_part){if _a==_ch{_dir_n=_n;}
if _a>0{_a-=1;}else{_a=_part-1;}
if !(_a>_part/4 && _a<_part-(_part/4)){_n+=1;}else{_n-=1;}
}

draw_sprite_part_ext(_spr,_img,_img_n*_w,_dir_n*_h,_w,_h,_x,_y,_sca,1,col,alpha);
//end
}



